<?php
namespace Inflightor\Controllers;

class Session {

	private $crudService;
	private $environment;
	private $entityManager;

	public function __construct($crudService, $environment, $entityManager) {
		$this->crudService = $crudService;
		$this->environment = $environment;
		$this->entityManager = $entityManager;
	}

	public function startSession($request, $response) {

		$user = $request->getRow();
		$this->environment->setCdFilial($user['cdfilialselecionada']);
		$this->environment->setNrOrgTrab($user['nrorg']);
		$this->environment->setFiliOper($this->getFiliOper());

		$this->addParamgeral($response);
		$this->addParamfilial($response);
	}

	private function addParamgeral($response) {
		$conditions = array(
			array(
				"columnName" => "NRORG",
				"operator" => "=",
				"value" => $this->environment->getNrOrg()
			)
		);
		$paramgeral = $this->crudService->getFilteredDataSet("paramgeral", $conditions);
		$response->addDataSet($paramgeral);
	}

	private function addParamfilial($response) {
		$conditions = array(
			array(
				"columnName" => "NRORG",
				"operator" => "=",
				"value" => $this->environment->getNrOrg()
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $this->environment->getCdFilial()
			)
		);
		$paramfilial = $this->crudService->getFilteredDataSet("paramfilial", $conditions);
		$response->addDataSet($paramfilial);
	}
	
	private function getFiliOper() {
		$conditions = array(
			array(
				"columnName" => "NRORG",
				"operator" => "=",
				"value" => $this->environment->getNrOrg()
			),
			array(
				"columnName" => "CDOPERADOR",
				"operator" => "=",
				"value" => $this->environment->getCdOperador()
			)
		); 
		$query = "SELECT F.CDFILIAL FROM FILIAL F JOIN FILIOPER FO ON F.CDFILIAL = FO.CDFILIAL WHERE FO.CDOPERADOR = :CDOPERADOR AND F.NRORG = :NRORG ORDER BY FO.CDFILIAL ASC, F.NMFILIAL ASC";
		$connection = $this->entityManager->getConnection();
		$stmt = $connection->prepare($query);
		$params = array(
			'CDOPERADOR' => $this->environment->getCdOperador(),
			'NRORG'      => $this->environment->getNrOrg()
		);
		$stmt->execute($params);
		$unidadesFiliOper = array();
		do {
			$cdfilial = $stmt->fetchColumn();
			if($cdfilial){
				array_push($unidadesFiliOper, $cdfilial);
			}
		} while($cdfilial);
		return $unidadesFiliOper;
    }
}