create or replace
PROCEDURE GERA_NOTAFISCAL_DADOSADIC (P_CDFILIAL    IN FILIAL.CDFILIAL%TYPE,
                                     P_NRLANCTONF  IN NOTAFISCAL.NRLANCTONF%TYPE,
                                     P_DTINICIO    IN DATE,
                                     P_DTFINAL     IN DATE,
                                     P_MENSAGEM    IN VARCHAR2 DEFAULT NULL,
                                     P_CDMENSAGEM  IN VARCHAR2 DEFAULT NULL) IS
V_NRDADOADIC     VARCHAR2(3);
V_MENSAGEM       VARCHAR2(255);
V_DTINICIO       VARCHAR2(10);
V_DTFINAL        VARCHAR2(10);
V_IDORIGDESTNF   NOTAFISCAL.IDORIGDESTNF%TYPE;
V_CDCLIENTE      NOTAFISCAL.CDCLIENTE%TYPE;
V_IDENTRSAIDOP   NOTAFISCAL.IDENTRSAIDOP%TYPE;
V_DSENDEDEVOEMBA VARCHAR2(255);
BEGIN
   --BUSCA MAIOR NRDADOADIC PARA INSERIR O PROXIMO
   SELECT NVL(MAX(NRDADOADIC),0)
     INTO V_NRDADOADIC
     FROM DADOSADIC
    WHERE CDFILIAL   = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF;

   V_NRDADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRDADOADIC) + 1)),3,0);

   IF ((P_MENSAGEM = '') OR (P_MENSAGEM IS NULL)) THEN
      V_MENSAGEM := 'PERODO DE APURAO '|| TO_CHAR(P_DTINICIO, 'DD/MM/YYYY') || ' A ' || TO_CHAR(P_DTFINAL, 'DD/MM/YYYY');
   ELSE
      V_MENSAGEM := P_MENSAGEM;
   END IF;

   INSERT INTO DADOSADIC (CDFILIAL,NRLANCTONF,NRDADOADIC,CDMENSAGEM, DSDADOADIC)
        VALUES (P_CDFILIAL, P_NRLANCTONF, V_NRDADOADIC, P_CDMENSAGEM, V_MENSAGEM);

   V_NRDADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRDADOADIC) + 1)),3,0);

   SELECT IDORIGDESTNF, 
          CDCLIENTE, 
          CASE IDENTRSAIDOP WHEN 'S' THEN 'E' ELSE CASE IDENTRSAIDOP WHEN 'E' THEN 'S' ELSE IDENTRSAIDOP END END AS IDENTRSAIDOP
     INTO V_IDORIGDESTNF, 
          V_CDCLIENTE, 
          V_IDENTRSAIDOP
     FROM NOTAFISCAL
    WHERE CDFILIAL = P_CDFILIAL
      AND NRLANCTONF = P_NRLANCTONF;
   
   IF V_IDORIGDESTNF = 'C' THEN
      FOR C_MENSCLIENTE IN (SELECT M.CDMENSAGEM, C.DSMENSCLIENTE
                              FROM MENSCLIENTE C LEFT JOIN MENSAGEM M ON (M.CDMENSAGEM = C.CDMENSAGEM)
                             WHERE C.CDCLIENTE = V_CDCLIENTE
                               AND C.IDENTRSAIDMENS <> V_IDENTRSAIDOP
                               AND (((C.CDMENSAGEM IS NOT NULL) AND (M.IDSITUACAOMENS  = 'A')) OR (C.CDMENSAGEM IS NULL))
                               AND NOT EXISTS (SELECT DSDADOADIC
                                                 FROM DADOSADIC
                                                WHERE (CDFILIAL = P_CDFILIAL)
                                                  AND (NRLANCTONF = P_NRLANCTONF)
                                                  AND (DSDADOADIC LIKE C.DSMENSCLIENTE || '%'))
                             ORDER BY C.NRMENSCLIENTE) 
      LOOP

         INSERT INTO DADOSADIC
            (CDFILIAL, 
             NRLANCTONF, 
             NRDADOADIC, 
             CDMENSAGEM, 
             DSDADOADIC)
         VALUES
            (P_CDFILIAL, 
             P_NRLANCTONF, 
             V_NRDADOADIC, 
             C_MENSCLIENTE.CDMENSAGEM, 
             C_MENSCLIENTE.DSMENSCLIENTE);

         V_NRDADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRDADOADIC) + 1)),3,0);
      END LOOP;
   END IF;
   
   BEGIN
      SELECT TRANSLATE(SUBSTR('Devolver as embalagens vazias no seguinte endereo: ' || 
             PRE.DSPOSTORECEMB ||
             ', ' || PRE.DSENDERECEMB || 
             CASE NVL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' || PRE.DSCOMPENDERECEMB END ||
             ', ' || B.NMBAIRRO ||
             ', CEP:' || PRE.NRCEPRECEMB ||
             ', ' || M.NMMUNICIPIO ||
             ', ' || E.SGESTADO ||
             ', ' || P.NMPAIS ||
             CASE NVL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' || PRE.NRTELERECEMB END ||
             CASE NVL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' || PRE.NRFAXRECEMB END, 1, 255), '', 'aaaaaeieieiicanoooooaouuuuyAAAAAEIEIEIIANOOOOOAOUUUUYC') AS DSENDEDEVOEMBA
        INTO V_DSENDEDEVOEMBA
        FROM NOTAFISCAL N JOIN ITEMPRODUTO I ON (N.CDFILIAL = I.CDFILIAL) AND
                                                (N.NRLANCTONF = I.NRLANCTONF)
                          JOIN PRODUTO PR ON (I.CDPRODUTO = PR.CDPRODUTO)
                          JOIN (SELECT P.CDPOSTORECEMB, PR.CDARVPROD
                                  FROM PRODPOSTORECEMB P JOIN PRODUTO PR ON (P.CDPRODUTO = PR.CDPRODUTO)) PPRE ON (INSTR(PR.CDARVPROD, NVL(RTRIM(PPRE.CDARVPROD), PR.CDARVPROD)) = 1)
                          JOIN CLIEPOSTORECEMB C ON (N.CDCLIENTE = C.CDCLIENTE) AND
                                                    (PPRE.CDPOSTORECEMB = C.CDPOSTORECEMB)
                          JOIN POSTORECEMB PRE ON (C.CDPOSTORECEMB = PRE.CDPOSTORECEMB)
                          JOIN PAIS P ON (PRE.CDPAIS = P.CDPAIS)
                          JOIN ESTADO E ON (PRE.CDPAIS = E.CDPAIS) AND
                                           (PRE.SGESTADO = E.SGESTADO)
                          JOIN MUNICIPIO M ON (PRE.CDPAIS = M.CDPAIS) AND
                                              (PRE.SGESTADO = M.SGESTADO) AND
                                              (PRE.CDMUNICIPIO = M.CDMUNICIPIO)
                          JOIN BAIRRO B ON (PRE.CDPAIS = B.CDPAIS) AND
                                           (PRE.SGESTADO = B.SGESTADO) AND
                                           (PRE.CDMUNICIPIO = B.CDMUNICIPIO) AND
                                           (PRE.CDBAIRRO = B.CDBAIRRO)
       WHERE N.CDFILIAL = P_CDFILIAL
         AND N.NRLANCTONF = P_NRLANCTONF
         AND NOT EXISTS (SELECT DSDADOADIC
                           FROM DADOSADIC
                          WHERE (CDFILIAL = P_CDFILIAL)
                            AND (NRLANCTONF = P_NRLANCTONF)
                            AND (DSDADOADIC LIKE TRANSLATE(SUBSTR('Devolver as embalagens vazias no seguinte endereo: ' || 
                                                 PRE.DSPOSTORECEMB ||
                                                 ', ' || PRE.DSENDERECEMB || 
                                                 CASE NVL(PRE.DSCOMPENDERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE ', ' || PRE.DSCOMPENDERECEMB END ||
                                                 ', ' || B.NMBAIRRO ||
                                                 ', CEP:' || PRE.NRCEPRECEMB ||
                                                 ', ' || M.NMMUNICIPIO ||
                                                 ', ' || E.SGESTADO ||
                                                 ', ' || P.NMPAIS ||
                                                 CASE NVL(PRE.NRTELERECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. Telefone: ' || PRE.NRTELERECEMB END ||
                                                 CASE NVL(PRE.NRFAXRECEMB, '!X!X!') WHEN '!X!X!' THEN '' ELSE '. FAX: ' || PRE.NRFAXRECEMB END, 1, 255), '', 'aaaaaeieieiicanoooooaouuuuyAAAAAEIEIEIIANOOOOOAOUUUUYC') || '%'));
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DSENDEDEVOEMBA := NULL;
      WHEN TOO_MANY_ROWS THEN
         RAISE_APPLICATION_ERROR(-20501, 'Operao bloqueada. Existem mais de um posto de recolhimento de embalagens cadastradas no sistema.', TRUE);
   END;
     
   IF (V_DSENDEDEVOEMBA IS NOT NULL) THEN
      INSERT INTO DADOSADIC
         (CDFILIAL, 
          NRLANCTONF, 
          NRDADOADIC, 
          CDMENSAGEM, 
          DSDADOADIC)
      VALUES
         (P_CDFILIAL, 
          P_NRLANCTONF, 
          V_NRDADOADIC, 
          '',
          V_DSENDEDEVOEMBA);

      V_NRDADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRDADOADIC) + 1)),3,0);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_NOTAFISCAL_DADOSADIC','6.00.xxx'); END;
/