/*-- ================================================================== --
-- SISTEMA         : GESTAO DE VENDAS                                   --
-- DATA DA CRIAO : 18/07/2007                                         --
-- CRIAO         : LUCIANA CORREA                                     --
-- OBJETIVOS       : INTEGRAAO RMC COM SAP                             --
-- ==================================================================== --
*/

drop table USR_RMC01;
drop table USR_RMC02;
drop table USR_RMC03;
drop table USR_CONTARMC;

create table USR_RMC01
(
    USR_EMPRESA       VARCHAR2(04)          not null,
    USR_FILIAL        VARCHAR2(04)          not null,
    USR_NRSEQRMC      VARCHAR2(10)          not null,
    USR_NRRMC         VARCHAR2(06)          null,
    USR_NRRNF         VARCHAR2(06)          null,
    USR_DTRMC         VARCHAR2(08)          not null,
    USR_DTGRAVA       VARCHAR2(08)          not null,
    USR_HRRMC         VARCHAR2(05)          not null,
    USR_DIFCAIXA      VARCHAR2(16)          not null,
    USR_DTIMPORT      VARCHAR2(08)          null,
    constraint PK_USR_RMC01 primary key (USR_EMPRESA, USR_FILIAL, USR_NRSEQRMC)
)
/

create table USR_RMC02
(
    USR_EMPRESA       VARCHAR2(04)          not null,
    USR_FILIAL        VARCHAR2(04)          not null,
    USR_NRSEQRMC      VARCHAR2(10)          not null,
    USR_CDCCL         VARCHAR2(10)          not null,
    USR_NRNOTA        VARCHAR2(06)          not null,
    USR_NRRMC         VARCHAR2(06)          null,
    USR_EMISS         VARCHAR2(08)          not null,
    USR_VALOR         VARCHAR2(16)          not null,
    USR_DTIMPORT      VARCHAR2(08)          null,
    constraint PK_USR_RMC02 primary key (USR_EMPRESA, USR_FILIAL, USR_NRSEQRMC, USR_CDCCL, USR_NRNOTA)
)
/

create table USR_RMC03
(
    USR_EMPRESA     VARCHAR2(04)           not null,
    USR_FILIAL      VARCHAR2(04)           not null,
    USR_NRSEQRMC    VARCHAR2(10)           not null,
    USR_ITEM        VARCHAR2(03)           not null,
    USR_IDITEM      VARCHAR2(01)           not null,
    USR_NRRMC       VARCHAR2(06)           null,
    USR_DC          VARCHAR2(01)           null,
    USR_CONTA       VARCHAR2(10)           null,
    USR_TPCTA       VARCHAR2(01)           null,
    USR_VALOR       VARCHAR2(16)           not null,
    USR_DTIMPORT    VARCHAR2(08)           null,
    constraint PK_USR_RMC03 primary key (USR_EMPRESA, USR_FILIAL, USR_NRSEQRMC, USR_ITEM, USR_IDITEM)
)
/

create table USR_CONTARMC
(
    USR_TPRECERMC   VARCHAR2(03)           not null,
    USR_NRCTARMC    VARCHAR2(10)           not null,
    USR_DSCTARMC    VARCHAR2(50)           not null,
    USR_TPCTARMC    VARCHAR2(01)           not null,
    USR_DCRMC       VARCHAR2(01)           not null,
    USR_NRCVALRMC   VARCHAR2(01)           null,
    constraint PK_USR_CONTARMC primary key (USR_TPRECERMC, USR_NRCTARMC)
)
/
